/* Copyright (C)  2005-2008 Infobright Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License version 2.0 as
published by the Free  Software Foundation.

This program is distributed in the hope that  it will be useful, but
WITHOUT ANY WARRANTY; without even  the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License version 2.0 for more details.

You should have received a  copy of the GNU General Public License
version 2.0  along with this  program; if not, write to the Free
Software Foundation,  Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307 USA  */

#include "../local.h"
#include "core/TempTable.h"
#include "core/Filter.h"

TempTable::TempTable(JustATable* t, int alias, Query* q)
	:	tree(NULL), group_by(false),	materialized(false), manage_used_tables(false), has_temp_table(false), m_conn(ConnectionInfoOnTLS.Get())
{
	tables.push_back(t);
	aliases.push_back(alias);
	query = q;

	if(t->TableType() == TEMP_TABLE) {
		has_temp_table = true;
		((TempTable *)t)->Materialize();
		filter.m_index->AddDimension_cross(t->NoObj());
	} else
		filter.m_index->AddDimension_cross(t->NoObj());

	no_obj = filter.m_index->NoTuples();
	no_cols = 0;
	for_subq = false;
}

void TempTable::JoinT(JustATable *t, int alias, JoinType jt)
{
	if(jt != JO_INNER)
		throw NotImplementedRCException("left/right/outer join is not implemented.");
	tables.push_back(t);
	aliases.push_back(alias);

	if(t->TableType() == TEMP_TABLE) {
		has_temp_table = true;
		((TempTable *)t)->Materialize();
		filter.m_index->AddDimension_cross(t->NoObj());
	} else
		filter.m_index->AddDimension_cross(t->NoObj());

	join_types.push_back(jt);

	if( filter.m_index->TooManyTuples() )
		no_obj = NULL_VALUE_64;			// a big, improper number, which we hope to be changed after conditions are applied
	else
		no_obj = filter.m_index->NoTuples();
}


