/* Copyright (C)  2005-2008 Infobright Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License version 2.0 as
published by the Free  Software Foundation.

This program is distributed in the hope that  it will be useful, but
WITHOUT ANY WARRANTY; without even  the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License version 2.0 for more details.

You should have received a  copy of the GNU General Public License
version 2.0  along with this  program; if not, write to the Free
Software Foundation,  Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307 USA  */

#ifndef DPN_H_
#define DPN_H_

#include "common/CommonDefinitions.h"
#include "common/bhassert.h"

class DPN
{
public:
	DPN(const DataPackId& data_pack_id, ushort no_obj, uint no_nulls,
			int pack_file, uint pack_addrs, _int64 min, _int64 max, _int64 sum, ushort size);
	~DPN();

public:
	uint 		GetNoObj() const		{ return (uint)no_obj + 1; }
	uint 		GetNoNulls() const		{ return no_nulls; }
	_int64		GetMin() const			{ return min_; }
	_int64		GetMax() const			{ return max_; }
	_int64		GetSum() const			{ return sum_; }
	ushort		GetSize() const			{ return size_; }
	int			GetPackFile() const		{ return pack_file; }
	uint		GetPackAddress() const	{ return pack_addrs; }

	ushort 		GetNoObjInternal() const{ return no_obj; }

	DataPackId	GetDataPackId() const	{ return data_pack_id; }

	void SetNoObj(uint no_obj)			{ this->no_obj = no_obj; }
	void SetNoNulls(uint no_nulls)		{ this->no_nulls = no_nulls; }
	void SetMin(_int64 min)				{ this->min_ = min; }
	void SetMax(_int64 max)				{ this->max_ = max; }
	void SetSum(_int64 sum)				{ this->sum_ = sum; }
	void SetSize(ushort size)			{ this->size_ = size; }
	void SetPackFile(int pack_file)		{ this->pack_file = pack_file; }
	void SetPackAddress(uint pack_addrs){ this->pack_addrs = pack_addrs; }

private:
	_int64		min_;
	_int64		max_;
	_int64		sum_;
	ushort		size_;
	int			pack_file;
	uint		pack_addrs;
	uint 		no_nulls;
	DataPackId	data_pack_id;
	ushort		no_obj;
};

#endif /*DPN_H_*/
