/* Copyright (C)  2005-2008 Infobright Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License version 2.0 as
published by the Free  Software Foundation.

This program is distributed in the hope that  it will be useful, but
WITHOUT ANY WARRANTY; without even  the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License version 2.0 for more details.

You should have received a  copy of the GNU General Public License
version 2.0  along with this  program; if not, write to the Free
Software Foundation,  Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307 USA  */

#include "RCAttrPack.h"
#include "RCAttr.h"
#include "core/tools.h"
#include "DataCache.h"
#include "shared/loader/RCAttrLoadBase.h"
#include "Transaction.h"

//CRITICAL_SECTION rc_save_pack_cs;

AttrPack::AttrPack(RCAttr& attr, int pack_no)
	:	m_prev_pack(NULL), m_next_pack(NULL), pack_no(pack_no), is_only_compressed(false),
		inserting_mode(attr.GetInsertingMode()), attr_type(attr.TypeName()),
		table(attr.table_number), column(attr.attr_number), dp(pack_no + attr.packs_omitted)
{
	nulls = 0;
	compressed_buf = 0;
	is_empty = true;
	previous_size = 0;
	SynchronizedDataCache::GlobalDataCache().PutAttrPackRO(table, column, dp, this);
}

AttrPack::~AttrPack()
{
	//attr->ForgetPack(pack_no);
	dealloc(nulls);
	dealloc(compressed_buf);
	nulls = 0;
	compressed_buf = 0;
}

bool AttrPack::UpToDate()				// return 1 iff there is no need to save
{
	if(!compressed_up_to_date)
		saved_up_to_date = false;
	return saved_up_to_date;
}

bool AttrPack::ShouldCompress()
{
	return inserting_mode == 1 && no_obj < 0x10000;
}

