/* Copyright (C)  2005-2008 Infobright Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License version 2.0 as
published by the Free  Software Foundation.

This program is distributed in the hope that  it will be useful, but
WITHOUT ANY WARRANTY; without even  the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License version 2.0 for more details.

You should have received a  copy of the GNU General Public License
version 2.0  along with this  program; if not, write to the Free
Software Foundation,  Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307 USA  */

#include "RCAttrTypeInfo.h"
#include "RCAttr.h"
#include "shared/common/DataFormat.h"

ushort AttributeTypeInfo::ObjPrefixSizeByteSize(AttributeType attr_type, EDF edf)
{
	return DataFormat::GetDataFormat(edf)->ObjPrefixSizeByteSize(attr_type);
}

bool AttributeTypeInfo::IsInteger32Type(AttributeType attr_type)
{
	if(	attr_type == RC_BYTEINT || attr_type == RC_SMALLINT ||
		attr_type == RC_INT 	|| attr_type == RC_MEDIUMINT
	)
		return true;
	return false;
}

bool AttributeTypeInfo::IsIntegerType(AttributeType attr_type)
{
	if(IsInteger32Type(attr_type) || attr_type == RC_BIGINT)
		return true;
	return false;
}

bool AttributeTypeInfo::IsFixedNumericType(AttributeType attr_type)
{
	if(IsIntegerType(attr_type) || attr_type == RC_NUM )
		return true;
	else
		return false;
}

bool AttributeTypeInfo::IsNumericType(AttributeType attr_type)
{
	if(IsIntegerType(attr_type) || attr_type == RC_NUM || ATI::IsRealType(attr_type))
		return true;
	return false;
}

bool AttributeTypeInfo::IsRealType(AttributeType attr_type)
{
	if(attr_type == RC_FLOAT || attr_type == RC_REAL)
		return true;
	return false;
}

bool AttributeTypeInfo::IsBinType(AttributeType attr_type)
{
	if(attr_type == RC_BYTE || attr_type == RC_VARBYTE || attr_type == RC_BIN)
		return true;
	return false;
}

bool AttributeTypeInfo::IsTxtType(AttributeType attr_type)
{
	if(attr_type == RC_STRING || attr_type == RC_VARCHAR)
		return true;
	return false;
}

bool AttributeTypeInfo::IsCharType(AttributeType attr_type)
{
	if(attr_type == RC_STRING )
		return true;
	return false;
}

bool AttributeTypeInfo::IsStringType(AttributeType attr_type)
{
	return AttributeTypeInfo::IsTxtType(attr_type) || AttributeTypeInfo::IsBinType(attr_type);
}

bool AttributeTypeInfo::IsDateTimeType(AttributeType attr_type)
{
	return	attr_type == RC_DATE		|| attr_type == RC_TIME 		|| attr_type == RC_YEAR ||
			attr_type == RC_DATETIME	|| attr_type == RC_TIMESTAMP;
}

bool AttributeTypeInfo::IsDateTimeNType(AttributeType attr_type)
{
	return attr_type == RC_TIME_N || attr_type == RC_DATETIME_N || attr_type == RC_TIMESTAMP_N;
}

int AttributeTypeInfo::TextSize(AttributeType attrt, ushort precision, ushort scale, DTCollation collation)
{
	return DataFormat::GetDataFormat(TXT_VARIABLE)->ExtrnalSize(attrt, precision, scale, &collation);
}

int AttributeTypeInfo::NULL32(AttributeType attrt)
{
	if(ATI::IsStringType(attrt))
		return NULL_VALUE_32;
	else if(attrt == RC_BYTEINT)
		return NULL_VALUE_C;
	else if(attrt == RC_SMALLINT)
		return NULL_VALUE_SH;
	else if(attrt == RC_INT)
		return NULL_VALUE_32;
	else if(attrt == RC_MEDIUMINT)
		return NULL_VALUE_32;
	else
		BHASSERT(0, "The process reached to an invalid path!");
	return NULL_VALUE_32;
}

long long AttributeTypeInfo::NULL64(AttributeType attrt)
{
	if(ATI::IsStringType(attrt) || attrt == RC_BIN || (attrt != RC_BIGINT && ATI::IsIntegerType(attrt)))
		return (_int64)AttributeTypeInfo::NULL32(attrt);
	return NULL_VALUE_64;
}

