/* Copyright (C)  2005-2008 Infobright Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License version 2.0 as
published by the Free  Software Foundation.

This program is distributed in the hope that  it will be useful, but
WITHOUT ANY WARRANTY; without even  the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License version 2.0 for more details.

You should have received a  copy of the GNU General Public License
version 2.0  along with this  program; if not, write to the Free
Software Foundation,  Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307 USA  */

#include "BHQuery.h"

namespace na {


DataSource* TableDescriptor::TransformToTree()
{
	dstable = new DSTable(bhtable);
	return dstable;
}

DSSelect* BHQuery::TransformToTree()
{
	DataSource* dstable = from->TransformToTree();
	DSSelect* dsselect = new DSSelect(dstable);

	// move SELECT expressions to 'dsselect'
	for(size_t i = 0; i < select.size(); i++) {
		select[i]->LinkVarsToDS();
		dsselect->AddExpr(select[i]);			// from now on, dsselect is the owner of the expressions
	}
	select.clear();

	// find which variables are used; set internal buffers for data values
	dsselect->SetBuffers(NULL);

	return dsselect;
}


}	// namespace na

