/* Copyright (C)  2005-2008 Infobright Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License version 2.0 as
published by the Free  Software Foundation.

This program is distributed in the hope that  it will be useful, but
WITHOUT ANY WARRANTY; without even  the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License version 2.0 for more details.

You should have received a  copy of the GNU General Public License
version 2.0  along with this  program; if not, write to the Free
Software Foundation,  Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307 USA  */

#ifndef _ENGINE_CONDITION_H_
#define _ENGINE_CONDITION_H_

#include <vector>
#include "BHItem.h"
#include <boost/logic/tribool.hpp>
#include "common/CommonDefinitions.h"

namespace na
{ 

	using boost::logic::tribool;
	BOOST_TRIBOOL_THIRD_STATE( BH_BOOST_UNKNOWN )		// BH_BOOST_UNKNOWN will be a name for the 3rd state of tribool used in evaluation of SQL conditions


/*	enum SimpleOperator 
	{	
		O_EQ, O_NOT_EQ, O_LESS, O_MORE, O_LESS_EQ, O_MORE_EQ, 
		O_IS_NULL, O_IS_NOT_NULL, O_BETWEEN, O_LIKE, O_IN, 
		O_FALSE, O_TRUE, O_EXISTS, O_ALL, O_ANY
	};
*/
	class Condition : public BHExprCond
	{
	public:
		virtual bool IsCondition()		{ return true; }
		virtual tribool Evaluate()		{ return false; }
	};
	
	class ConditionOR : public Condition
	{
		std::vector<Condition*> args;
	};

	class ConditionAND : public Condition
	{
		std::vector<Condition*> args;
	};

	class ConditionNOT : public Condition
	{
	};
	class ConditionREL : public Condition
	{
		Operator oper;
		Expression* left;
		Expression* right;
	};

}
#endif

