/* Copyright (C)  2005-2008 Infobright Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License version 2.0 as
published by the Free  Software Foundation.

This program is distributed in the hope that  it will be useful, but
WITHOUT ANY WARRANTY; without even  the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License version 2.0 for more details.

You should have received a  copy of the GNU General Public License
version 2.0  along with this  program; if not, write to the Free
Software Foundation,  Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307 USA  */

#include "system/SharedMemOut.h"
#include "system/MemoryManagement/Initializer.h"
#include "shared/core/RCTableImpl.h"
#include "system/BHToolkit.h"
#include "system/IOParameters.h"
#include "system/FileOut.h"
#include "core/WinTools.h"
#include "core/tools.h"
#include "shared/loader/BHLoader.h"
#include "shared/loader/BHLoaderApp.h"
#include "shared/core/RCEngine.h"

int main(int argc, char *argv[])
{
	if (argc < 3)
	 	return BHERROR_UNKNOWN;

	BHLoader bhl;
	bhl.Init(argv[1], argv[2]);
	try {
		MemoryManagerInitializer::Instance(bhl.CompressedHeapSize(), bhl.MainHeapSize(), bhl.CompressedHeapSize() / 10,
				bhl.MainHeapSize() / 10);
	} catch (OutOfMemoryRCException& e) {
		return BHERR0R_OUT_OF_MEMORY;
	}

	InitRSIManager();
	InitCachingLevel();

#	ifdef FUNCTIONS_EXECUTION_TIMES
	fet = new FunctionsExecutionTimes();
#	endif

	/**********
	 int status= 0;
	 SharedMemOut server_out(bhl.RCLogMessage(), BHLoader::s_rclog_message_maxsize, bhl.EventName(), argv[2], status);
	 if (!status) return BHERROR_UNKNOWN;
	 SharedMemOut *pserver_out = &server_out;
	 rclog.addOutput(&server_out);
	 **********/

	std::string report_file_name = argv[2]; // argv[2] is an full path to some file now
	report_file_name += BHLOADER_REPORT_EXTENSTION;
	FileOut fo(report_file_name.c_str());
	int r;

	try {
		rclog.addOutput(&fo);
	} catch (...) {
		r = BHERROR_UNKNOWN;
		goto cleanup;
	}

	process_type = ProcessType::BHLOADER;
	r = LoadData(argv[1], argv[2]);

cleanup:
	MemoryManagerInitializer::deinit();
	bhl.DeInit(false);
	fo.close();
	return r;
}

