/* Copyright (C)  2005-2008 Infobright Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License version 2.0 as
published by the Free  Software Foundation.

This program is distributed in the hope that  it will be useful, but
WITHOUT ANY WARRANTY; without even  the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License version 2.0 for more details.

You should have received a  copy of the GNU General Public License
version 2.0  along with this  program; if not, write to the Free
Software Foundation,  Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307 USA  */

#ifndef DATALOADER_H_
#define DATALOADER_H_

#include <boost/utility.hpp>

#include "core/bintools.h"
#include "common/CommonDefinitions.h"
#include "compress/tools.h"
#include "system/IOParameters.h"
#include "common/bhassert.h"

class RCAttrLoad;
class DataParser;
class Buffer;

class DataLoader : public boost::noncopyable
{
	typedef std::vector<std::pair<int, RCAttrLoad*> > ThreadsHandles;
public:
	_uint64	Proceed();
	virtual ~DataLoader();
private:
	DataLoader(std::vector<RCAttrLoad*> attrs, Buffer& buffer, const IOParameters& iop);
	int		LoadData();
	void	Abort();
public:
	static std::auto_ptr<DataLoader>
			CreateDataLoader(std::vector<RCAttrLoad*> attrs, Buffer& buffer, const IOParameters& iop);
private:
	std::vector<RCAttrLoad*> 	attrs;
	Buffer*		 			buffer;
	IOParameters 			iop;
	std::auto_ptr<DataParser> 	parser;
	int						no_prepared;
	_uint64 				no_loaded_rows;

};

#endif /*DATALOADER_H_*/
