/* Copyright (C)  2005-2008 Infobright Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License version 2.0 as
published by the Free  Software Foundation.

This program is distributed in the hope that  it will be useful, but
WITHOUT ANY WARRANTY; without even  the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License version 2.0 for more details.

You should have received a  copy of the GNU General Public License
version 2.0  along with this  program; if not, write to the Free
Software Foundation,  Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307 USA  */

#ifndef _BHDATA_LOADER_H_
#define _BHDATA_LOADER_H_

#include <iostream>
#include <ctype.h>
#include <math.h>
#include "common/CommonDefinitions.h"
#include "compress/tools.h"
#include "common/bhassert.h"

class NewValuesSet;
class Buffer;

class DataParserForText : public DataParser
{
	friend class NewValuesSet;

	char	TranslateEscapedChar(char c);
	void	ProcessEscChar(int i);

	bool** qualifier_present;
public:
	DataParserForText(std::vector<RCAttrLoad*> attrs, Buffer& buffer, const IOParameters& iop);
	virtual ~DataParserForText();
public:
	virtual int		GetRowSize(char* buf_ptr, int rno);
	virtual void	PrepareNulls();
	virtual void	PrepareObjsSizes();
	virtual void 	PrepareValuesPointers();
	virtual uint 	GetValueSize(int ono);
	virtual bool 	FormatSpecificDataCheck();
	virtual void	FormatSpecificProcessing();
public:
	char*	GetValue(int ono);
	void	GetCRLF();
	bool 	IsEOR(const char* ptr) const;

public:
	uint**	no_esc_char;
	bool	prepared;
	ushort	crlf;
	char	delimiter;
	uchar	string_qualifier;
	char	escape_char;
private:
	
	/*! \brief The input text file can contain header information
	 * (BOM) describing byte ordering. The function moves the 
	 * \e buf_start pointer to the first byte after BOM
	// \return void 
	*/
	void	ShiftBufferByBOM();
};


#endif //_CORE_BHDATA_LOADER_H_

