/* Copyright (C)  2005-2008 Infobright Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License version 2.0 as
published by the Free  Software Foundation.

This program is distributed in the hope that  it will be useful, but
WITHOUT ANY WARRANTY; without even  the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License version 2.0 for more details.

You should have received a  copy of the GNU General Public License
version 2.0  along with this  program; if not, write to the Free
Software Foundation,  Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307 USA  */

#ifdef _MSC_VER

#ifndef IBPIPE_H_
#define IBPIPE_H_

#include <string>

#include "system/RCException.h"
#include "system/IBFileSystem.h"
#include "system/ib_system.h"
#include <windows.h>
#include "system/LargeBuffer.h"

typedef unsigned int    ib_pmode;


class IBPipe : public IBStream {

		bool IsOpen();
		int Open() 	throw(DatabaseRCException);
		int Open(std::string const& filename, int flags, ib_pmode mode) throw(DatabaseRCException);
		int Close();
		int OpenReadOnly(std::string const& filename, int create = 0, int timeout = 0) throw(DatabaseRCException);
		int OpenCreateEmpty(std::string const& filename, int create = 0, int timeout = 0) throw(DatabaseRCException);
		int OpenWriteAppend(std::string const& filename, int create = 0, int timeout = 0) throw(DatabaseRCException);
		uint WriteExact(const void* buf, uint count) 	throw(DatabaseRCException);
		uint Read(void* buf, uint count) 	throw(DatabaseRCException);

		HANDLE curpipe;


public:
		IBPipe();
		virtual ~IBPipe();

};

#endif /* IBPIPE_H_ */
#endif
