/* Copyright (C)  2005-2008 Infobright Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License version 2.0 as
published by the Free  Software Foundation.

This program is distributed in the hope that  it will be useful, but
WITHOUT ANY WARRANTY; without even  the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License version 2.0 for more details.

You should have received a  copy of the GNU General Public License
version 2.0  along with this  program; if not, write to the Free
Software Foundation,  Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307 USA  */

#include "MemoryBlock.h"

template<typename MEM_HANDLE>
MemoryBlock<MEM_HANDLE>::MemoryBlock()
	: size(0), address(0), prev(0), next(0)
{
}

template<typename MEM_HANDLE>
MemoryBlock<MEM_HANDLE>::~MemoryBlock()
{
	if(prev)
		prev->next = next;
	if(next)
		next->prev = prev;
}

template<typename MEM_HANDLE>
bool MemoryBlock<MEM_HANDLE>::Merge(MemoryBlock<MEM_HANDLE> *blck)
{
	/*
		reverse situation should not be processed, because than
		blck would be a base block (with starting address)
	*/
	if( ((size_t)this->address + this->size) == (size_t)blck->address)
	{
		this->size += blck->size;
		this->next = blck->next;
		if(blck->getNext())
			blck->getNext()->setPrev(this);
		return true;
	}
	else
		return false;
}

template <typename MEM_HANDLE>
MemoryBlock<MEM_HANDLE>* MemoryBlock<MEM_HANDLE>::Split(size_t new_size)
{
	if(this->size > new_size)
	{
		MemoryBlock* blck = new MemoryBlock();
		blck->setSize(this->size - new_size);
		blck->setAddress((MEM_HANDLE)((size_t)this->address + new_size));
		blck->setType(BLOCK_FREE);
		blck->setOwner(NULL);

		blck->setPrev(this);
		blck->setNext(this->next);
		if(blck->getNext())
			blck->getNext()->setPrev(blck);

		size = new_size;
		next = blck;
		return blck;
	}

	return NULL;
}

template class MemoryBlock<void*>;

