/* Copyright (C)  2005-2008 Infobright Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License version 2.0 as
published by the Free  Software Foundation.

This program is distributed in the hope that  it will be useful, but
WITHOUT ANY WARRANTY; without even  the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License version 2.0 for more details.

You should have received a  copy of the GNU General Public License
version 2.0  along with this  program; if not, write to the Free
Software Foundation,  Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307 USA  */

#ifdef _SYSTEM_WRSYNC_H_
#define _SYSTEM_WRSYNC_H_

#ifdef MSC_VER
#include <windows.h>
#else
#include <semaphore.h>
#endif

class WriteSync
{
public:
	WriteSync(void);
	~WriteSync(void);

	void LockByReader();        // locks the object by a next reader
	void UnlockByReader();      // unlocks the object by a reader

	void WaitForNoReaders();     	// waits for the state of no other readers,
	bool NoReaders();      // checks whether there is no readers

private:

	pthread_mutex_t m_WritersCS;
	pthread_mutex_t  m_ReadersCS;
	int m_nReadingLocksByWriter;

#ifdef __GNUC__
	std::vector<pthread_t> m_Readers;
	sem_t  m_NoReadersSem;  //must emulate the same behavior using a POSIX semaphore
#else
	std::vector<unsigned long> m_Readers;
	HANDLE m_NoReadersEvent;
#endif
};
#endif //_SYSTEM_WRSYNC_H_

