/* Copyright (C)  2005-2008 Infobright Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License version 2.0 as
published by the Free  Software Foundation.

This program is distributed in the hope that  it will be useful, but
WITHOUT ANY WARRANTY; without even  the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License version 2.0 for more details.

You should have received a  copy of the GNU General Public License
version 2.0  along with this  program; if not, write to the Free
Software Foundation,  Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307 USA  */

#ifndef _TYPES_AVALUE_H_
#define _TYPES_AVALUE_H_

#include "common/CommonDefinitions.h"


class AValue
{
public:

	void	SetNull()		{ isnull = true; }
	bool	IsNull()		{ return isnull; }
	virtual ~AValue()		{}

protected:
	AValue(bool n)			:isnull(n) {}

	bool	isnull;
};


// Signed integer of up to 64 bits.
class VInteger : public AValue
{
protected:
	_int64	val;

public:
	VInteger()				:AValue(true)			{}
	VInteger(_int64 v)		:AValue(false), val(v)	{}

	void Set(_int64 v)		{ isnull = false; val = v; }
	_int64 Get()				{ return val; }

	static void OperNeg(AValue* res, AValue* arg);
};





#endif

