/* Copyright (C)  2005-2008 Infobright Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License version 2.0 as
published by the Free  Software Foundation.

This program is distributed in the hope that  it will be useful, but
WITHOUT ANY WARRANTY; without even  the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License version 2.0 for more details.

You should have received a  copy of the GNU General Public License
version 2.0  along with this  program; if not, write to the Free
Software Foundation,  Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307 USA  */

#ifndef _SYSTEM_INFORMATION_H_
#define _SYSTEM_INFORMATION_H_

#ifdef __GNUC__
#if defined(linux) || defined(_linux) || \
	defined(__linux) || defined(__linux__)
#include <linux/kernel.h>
#else
// include other Unix specific header file
#endif
#include <sys/sysinfo.h>
#else
#include <Psapi.h>
#endif
#include "common/CommonDefinitions.h"
#include "system/RCException.h"

#ifdef __GNUC__

struct _meminfo
{
	long long ram_total;
	long long ram_use;
	long long ram_free;
	long long swap_total;
	long long swap_use;
	long long swap_free;
};

int getmeminfo(_meminfo &meminfo);

_uint64 GetProcessVirtualMemory(pid_t process_id) throw(RCException);
_uint64 ExtractProcessVirtualMemory(std::string statistics_string) throw(RCException);

#endif

size_t VirtualMemoryUsage();
unsigned long long PhysicalMemoryAvailable();

#endif // _SYSTEM_INFORMATION_H_
